VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim m(3) As Long 'SMU port numbers f3
m(0) = 2 'SMU1: base
m(1) = 4 'SMU2: collector
m(2) = 1 'SMU4: emitter
ret = age5270_setSwitch(vi, m(2), 1) '8
ret = age5270_setSwitch(vi, m(1), 1)
ret = age5270_setSwitch(vi, m(0), 1)
check_err vi, ret '11
sweep_meas vi, ret, m() '13
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '15
check_err vi, ret
End Sub
Sub sweep_meas(vi As Long, ret As Long, m() As Long) '1
Dim vc As Double '3
Dim ve As Double
Dim vb1 As Double
Dim vb2 As Double
Dim iccomp As Double
Dim ibcomp As Double
Dim iecomp As Double
Dim hold As Double
Dim delay As Double
Dim s_delay As Double
Dim pcomp As Double
Dim nop As Long
Dim n As Long
Dim smpl As Long
vc = 3
iccomp = 0.1
ve = 0
iecomp = 0.1
vb1 = 0.3
vb2 = 0.8
ibcomp = 0.001
hold = 0
delay = 0
s_delay = 0
pcomp = 0
nop = 11
smpl = 5
n = nop * 2 '30
Dim mch(3) As Long '32
Dim mode(2) As Long
Dim range(2) As Double
mch(0) = m(0) 'base
mch(1) = m(1) 'collector
mch(2) = 0
mode(0) = 1 'current measurement
mode(1) = 1 'current measurement
range(0) = -0.001 ' 1 mA range fixed
range(1) = -0.1 '100 mA range fixed f41
Dim sc() As Double 'primary sweep output data f43
Dim md() As Double 'sweep measurement data
Dim st() As Long 'status data at each step
Dim tm() As Double 'time data at each step
ReDim Preserve sc(nop) As Double
ReDim Preserve md(n) As Double
ReDim Preserve st(n) As Long
ReDim Preserve tm(n) As Double '50
CommandButton1.Caption = "Measurement in progress . . ." '52
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_setAdc(vi, age5270_HSPEED_ADC, age5270_INTEG_MANUAL, smpl, age5270_FLAG_OFF) '56
ret = age5270_setAdcType(vi, age5270_CH_ALL, age5270_HSPEED_ADC)
ret = age5270_resetTimestamp(vi)
check_err vi, ret
ret = age5270_force(vi, m(2), age5270_VF_MODE, 0, ve, iecomp, 0) '61
ret = age5270_force(vi, m(1), age5270_VF_MODE, 0, vc, iccomp, 0)
ret = age5270_setIv(vi, m(0), age5270_SWP_VF_SGLLIN, 0, vb1, vb2, nop, hold, delay, s_delay, ibcomp, pcomp)
check_err vi, ret
ret = age5270_msweepMiv(vi, mch(0), mode(0), range(0), rep, sc(0), md(0), st(0), tm(0)) '66
check_err vi, ret
ret = age5270_zeroOutput(vi, age5270_CH_ALL) '69
check_err vi, ret
CommandButton1.Caption = "Measurement completed." '72
If rep = nop Then '74
save_data nop, md(), st(), sc(), tm(), vi, ret, m()
Else
msg = rep & " measurement steps were returned. It must be " & nop & " steps. "
MsgBox msg, vbOKOnly, ""
End If '79
End Sub '81
Sub save_data(nop As Long, md() As Double, st() As Long, sc() As Double, tm() As Double, vi As Long, ret As Long, m() As Long)
Dim i As Integer 'array counter for primary sweep f3
Dim val As String 'data to be saved to a file
val = "Vb (V), Ib (mA), Ic (mA), Time_b (sec), Time_c (sec), Status_b, Status_c"
For i = 0 To nop - 1 '7
val = val & Chr(13) & Chr(10) & sc(i) & "," & md(2 * i) * 1000 & "," & md(2 * i + 1) * 1000
val = val & "," & tm(2 * i) & "," & tm(2 * i + 1) & "," & st(2 * i) & "," & st(2 * i + 1)
Next i
Dim fname As String 'data file name f12
Dim fnum As Integer 'file number
fname = "data1.txt"
fnum = 1
'saves data into the file specified by fname
Open fname For Output Access Write Lock Read Write As fnum
Print #fnum, val
Close fnum
'displays data on a MsgBox
Dim title As String
Dim rbx As Integer '23
title = "Sweep Measurement Result"
val = val & Chr(10) & Chr(10) & "Data save completed."
val = val & Chr(10) & Chr(10) & "Do you want to perform measurement again? "
rbx = MsgBox(val, vbYesNo, title)
If rbx = vbYes Then
sweep_meas vi, ret, m()
End If '30
End Sub
Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
