Imports Ivi.visa.interop

Module Module1


    Sub Main()
        Dim B1500 As IResourceManager
        Dim session As IMessage
        B1500 = New ResourceManager
        session = B1500.Open("GPIB0::17::INSTR")
        session.WriteString("*RST" & vbLf)
        MsgBox("Click OK to start measurement.", vbOKOnly, "")
        Console.WriteLine("Measurement in progress. . ." & Chr(10))

        Dim t() As Integer = {4, 3, 2, 1}
        Dim term As String = t(0) & "," & t(1) & "," & t(2) & "," & t(3)
        session.WriteString("CN " & term & vbLf)
        perform_meas(session, t)

        session.WriteString("CL" & vbLf)
        session.Close()
        MsgBox("Click OK to stop the program.", vbOKOnly, "")
        Console.WriteLine("Measurement completed." & Chr(10))
    End Sub

    Sub perform_meas(ByVal session As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0                         't(0): Emitter
        Dim j As Integer = 0                         't(1): Base
        Dim nop1 As Integer = 11                     't(2): Collector
        Dim nop2 As Integer = 1                      't(3): not use
        Dim data(nop2 - 1, nop1 - 1) As String
        Dim value As String = "Vb (V), Ib (mA), Tb (sec), Stat_b, Ic (mA), Tc (sec), Stat_c"
        Dim fname As String = "C:\Agilent\prog_ex\data11.txt"
        Dim title As String = "Measurement Result"
        Dim msg As String = "No error."
        Dim err As Integer = 0

        Dim vc As Double = 3
        Dim vb1 As Double = 0.1
        Dim vb2 As Double = 0.9
        Dim ibcomp As Double = 0.1
        Dim pbcomp As Double = 0.1
        Dim hold As Double = 0
        Dim delay As Double = 0
        Dim s_delay As Double = 0
        Dim rep As Integer = nop1

        Dim mret As String
        Dim sc(nop1) As Double
        Dim md1(nop1) As Double
        Dim st1(nop1) As String
        Dim tm1(nop1) As Double
        Dim md2(nop1) As Double
        Dim st2(nop1) As String
        Dim tm2(nop1) As Double
        session.WriteString("FMT 1,1" & vbLf)   'ASCII, <CRLF EOI>, w/sweep source data
        session.WriteString("TSC 1" & vbLf)     'enables time stamp output
        session.WriteString("FL 1" & vbLf)      'sets filter on
        session.WriteString("AV 10,1" & vbLf)   'sets number of samples for 1 data
        session.WriteString("MM 16," & t(1) & "," & t(2) & vbLf)   '16: multi channel sweep
        session.WriteString("CMM" & t(1) & ",1" & vbLf)     '1: current measurement
        session.WriteString("CMM" & t(2) & ",1" & vbLf)     '1: current measurement
        session.WriteString("RI" & t(1) & ",-19" & vbLf)    '-19: 100 mA fixed range
        session.WriteString("RI" & t(2) & ",-19" & vbLf)    '-19: 100 mA fixed range
        session.WriteString("WT " & hold & "," & delay & "," & s_delay & vbLf)
        session.WriteString("WM 2,1" & vbLf)                'stops any abnormal
        session.WriteString("ERR? 1" & vbLf) : err = session.ReadString(4 + 2)
        If err <> 0 Then session.WriteString("DZ" & vbLf) : GoTo Check_err

        session.WriteString("WV" & t(1) & ",1,0," & vb1 & "," & vb2 & "," & nop1 & "," & ibcomp & "," & pbcomp & vbLf)
        session.WriteString("DV" & t(2) & ",0," & vc & ",0.1" & vbLf)
        session.WriteString("DV" & t(0) & ",0,0,0.1" & vbLf)    'out= 0 V, comp= 0.1 A
        session.WriteString("TSR" & vbLf)
        session.WriteString("XE" & vbLf)
        session.WriteString("*OPC?" & vbLf) : rep = session.ReadString(1 + 2)
        session.WriteString("ERR? 1" & vbLf) : err = session.ReadString(4 + 2)
        If err <> 0 Then session.WriteString("DZ" & vbLf) : GoTo Check_err
        session.WriteString("NUB?" & vbLf) : rep = session.ReadString(3 + 2)
        If rep <> nop1 * 5 Then session.WriteString("DZ" & vbLf) : GoTo Check_nop

        mret = session.ReadString(16 * 5 * nop1 + 1)
        For i = 0 To nop1 - 1
            tm1(i) = Val(Mid(mret, 4 + 16 * 5 * i, 12))
            st1(i) = Mid(mret, 17 + 16 * 5 * i, 3)
            md1(i) = Val(Mid(mret, 20 + 16 * 5 * i, 12))
            tm2(i) = Val(Mid(mret, 36 + 16 * 5 * i, 12))
            st2(i) = Mid(mret, 49 + 16 * 5 * i, 3)
            md2(i) = Val(Mid(mret, 52 + 16 * 5 * i, 12))
            sc(i) = Val(Mid(mret, 68 + 16 * 5 * i, 12))
            data(j, i) = Chr(13) & Chr(10) & sc(i) & ", " & md1(i) * 1000 & ", " & tm1(i) & ", " & st1(i) & ", " & md2(i) * 1000 & ", " & tm2(i) & ", " & st2(i)
        Next

        session.WriteString("DZ" & vbLf)
        save_data(fname, title, value, data, nop1, nop2, session, t)
        Exit Sub

Check_err:
        session.WriteString("EMG? " & err & vbLf) : msg = session.ReadString(256)
        MsgBox("Instrument error: " & err & Chr(10) & msg, vbOKOnly, "")
        Exit Sub

Check_nop:
        MsgBox("No. of data: " & rep & " (not " & nop1 * 5 & ")", vbOKOnly, "")
    End Sub

    Sub save_data(ByVal fname As String, ByVal title As String, ByVal value As String, ByVal data(,) As String, ByVal nop1 As Integer, ByVal nop2 As Integer, ByVal session As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0
        Dim j As Integer = 0
        FileOpen(1, fname, OpenMode.Output, OpenAccess.Write, OpenShare.LockReadWrite)
        Print(1, value)
        For j = 0 To nop2 - 1
            For i = 0 To nop1 - 1
                Print(1, data(j, i))
            Next
        Next
        FileClose(1)

        Dim rbx As Integer
        For j = 0 To nop2 - 1
            For i = 0 To nop1 - 1
                value = value & data(j, i)
            Next
        Next
        value = value & Chr(10) & Chr(10) & "Data save completed."
        value = value & Chr(10) & Chr(10) & "Do you want to perform measurement again?"
        rbx = MsgBox(value, vbYesNo, title)
        If rbx = vbYes Then perform_meas(session, t)
    End Sub

End Module
