Imports Ivi.visa.interop

Module Module1


    Sub Main()
        Dim B1500 As IResourceManager : Dim unit1 As IMessage
        B1500 = New ResourceManager
        unit1 = B1500.Open("GPIB0::17::INSTR")
        Dim E5270 As IResourceManager : Dim unit2 As IMessage
        E5270 = New ResourceManager
        unit2 = E5270.Open("GPIB0::22::INSTR")
        unit1.WriteString("*RST" & vbLf)
        unit2.WriteString("*RST" & vbLf)
        MsgBox("Click OK to start measurement.", vbOKOnly, "")
        Console.WriteLine("Measurement in progress. . ." & Chr(10))

        Dim t() As Integer = {1, 2, 1, 2}
        Dim term1 As String = t(0) & "," & t(1) : Dim term2 As String = t(2) & "," & t(3)
        unit1.WriteString("CN " & term1 & vbLf)
        unit2.WriteString("CN " & term2 & vbLf)
        perform_meas(unit1, unit2, t)

        unit1.WriteString("CL" & vbLf)
        unit2.WriteString("CL" & vbLf)
        unit1.Close()
        unit2.Close()
        MsgBox("Click OK to stop the program.", vbOKOnly, "")
        Console.WriteLine("Measurement completed." & Chr(10))
    End Sub

    Sub perform_meas(ByVal unit1 As IMessage, ByVal unit2 As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0                         't(0): Drain
        Dim j As Integer = 0                         't(1): Gate
        Dim nop1 As Integer = 1                      't(2): Source
        Dim nop2 As Integer = 1                      't(3): Substrate
        Dim data(nop2 - 1, nop1 - 1) As String
        Dim value As String = "Id (mA), Status"
        Dim fname As String = "C:\Agilent\prog_ex\data14.txt"
        Dim title As String = "Measurement Result"
        Dim msg As String = "No error."
        Dim err As Integer = 0

        Dim vg As Double = 0.8 : Dim igcomp As Double = 0.05
        Dim vd As Double = 2.5 : Dim vs As Double = 0 : Dim icomp As Double = 0.1
        Dim ret As Integer

        unit1.WriteString("FMT 1" & vbLf)
        unit1.WriteString("TM 1" & vbLf)
        unit1.WriteString("AV -1" & vbLf)
        unit1.WriteString("MM 1," & t(0) & vbLf)
        unit2.WriteString("DV" & t(3) & ",0," & vs & "," & icomp & vbLf)
        unit2.WriteString("DV" & t(2) & ",0," & vs & "," & icomp & vbLf)
        unit1.WriteString("DV" & t(0) & ",0," & vd & "," & icomp & vbLf)
        unit1.WriteString("DV" & t(1) & ",0," & vg & "," & igcomp & vbLf)

        unit1.WriteString("WS 2" & vbLf)
        unit1.WriteString("XE" & vbLf)
        unit2.WriteString("OS" & vbLf)

        'unit1.WriteString("TM 3" & vbLf)
        'unit1.WriteString("*OPC?" & vbLf) : ret = unit1.ReadString(1 + 2)
        'unit2.WriteString("OS" & vbLf)

        'unit1.WriteString("PA" & vbLf)
        'unit2.WriteString("OS" & vbLf)
        'unit1.WriteString("XE" & vbLf)

        unit1.WriteString("*OPC?" & vbLf) : ret = unit1.ReadString(1 + 2)
        unit1.WriteString("ERR? 1" & vbLf) : err = unit1.ReadString(4 + 2)
        If err <> 0 Then
            unit1.WriteString("DZ" & vbLf)
            unit2.WriteString("DZ" & vbLf)
            GoTo Check_err
        End If

        Dim mret As String = unit1.ReadString(17)
        Dim status As String = Left(mret, 3)
        Dim meas As Double = Val(Mid(mret, 4, 12))

        data(j, i) = Chr(13) & Chr(10) & meas * 1000 & ", " & status

        unit1.WriteString("DZ" & vbLf)
        unit2.WriteString("DZ" & vbLf)
        save_data(fname, title, value, data, nop1, nop2, unit1, unit2, t)
        Exit Sub

Check_err:
        unit1.WriteString("EMG? " & err & vbLf) : msg = unit1.ReadString(256)
        MsgBox("Instrument error: " & err & Chr(10) & msg, vbOKOnly, "")
        Exit Sub
    End Sub

    Sub save_data(ByVal fname As String, ByVal title As String, ByVal value As String, ByVal data(,) As String, ByVal nop1 As Integer, ByVal nop2 As Integer, ByVal unit1 As IMessage, ByVal unit2 As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0
        Dim j As Integer = 0
        FileOpen(1, fname, OpenMode.Output, OpenAccess.Write, OpenShare.LockReadWrite)
        Print(1, value)
        For j = 0 To nop2 - 1
            'Print(1, Chr(13) & Chr(10) & "Unit" & j + 1)
            For i = 0 To nop1 - 1
                Print(1, data(j, i))
            Next
        Next
        FileClose(1)

        Dim rbx As Integer
        For j = 0 To nop2 - 1
            'value = value & Chr(10) & "Unit" & j + 1
            For i = 0 To nop1 - 1
                value = value & data(j, i)
            Next
        Next
        value = value & Chr(10) & Chr(10) & "Data save completed."
        value = value & Chr(10) & Chr(10) & "Do you want to perform measurement again?"
        rbx = MsgBox(value, vbYesNo, title)
        If rbx = vbYes Then perform_meas(unit1, unit2, t)
    End Sub

End Module
