#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;

#ifdef E5270_TIS_H
	ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL);
	if ( ret != 0 ) {
					printf( "Failed to open E5270. Exit program.\n" );
					return( -1 );
					}
#endif

int drain, gate, source, substrate, status;
double range, vout, comp, start, hold, delay;
double result;

drain = 15;
gate = 16;
source = 17;
substrate = 18;
range = 0.0;
vout = 5.0;
comp = 0.05;
start = -5.0;
hold = 0.01;
delay = 0.01;

init_system();
connect_pin(SMU1, drain);
connect_pin(SMU2, gate);
connect_pin(SMU4, source);
connect_pin(SMU6, substrate);

force_v(substrate, 0.0, 0.0, 0.05);
force_v(source, 0.0, 0.0, 0.05);
force_v(gate, 0.0, 0.0, 0.01);
set_ileak(drain,range, vout, comp, start, hold, delay);
measure_ileak(drain, &result, &status, ILEAK_INTVL_SHORT);

disable_port(0);
disconnect_all();

printf(" Ileak (mA)   Status\n");
printf(" %8.6f     %d\n", result*1000, status);

#ifdef E5270_TIS_H
	close_E5270();
#endif
	return( 0 );
}